<?php
/**
*
* @package calendar_ajax
* @version $Id: calendar_ajax.php 2008-09-08 20:29:00Z livewirestu $
* @copyright (c) 2008 www.phpbbireland.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin(false);
$auth->acl($user->data);
$user->setup('mods/calendar');

include_once($phpbb_root_path . 'includes/functions_calendar.' . $phpEx);

if($_GET['event_repeat'] == 1)
{  
    include_once($phpbb_root_path . 'common.' . $phpEx);
    
    if(!isset($_GET['container']))
    {
        die('No container specified');   
    }

    $times = validate_event_times(true);
    
    if($times['valid'] == true)
    {
        $repeat_params = validate_repeat_params(true, true);
        if($repeat_params['valid'] == true)
        {
            $repeat_info = generate_repeat_event_info(0, $times['start'], $times['end'], $repeat_params['repeat_code']);        
            $return_array['data'] = $repeat_info['list'];
        }
        else
        {
            $return_array['data'] = implode('<br />', $repeat_params['error']);
        }    
    }
    else
    {
        $return_array['data'] = implode('<br />', $times['error']);
    }
    
    $return_array['mode'] = 'update_field'; // So the client side handler knows what to do
    $return_array['container'] = request_var('container', '');      
}    

if(request_var('mode', '') == 'populate_table')
{
    $month = request_var('cal_h_month', '');
    $year = request_var('cal_h_year', '');
    $action = request_var('action', '');
    
    if(empty($month) || empty($year))
    {
        // Something went wrong
        return false;    
    }
    
    if($action == 'prev')
    {
        $month -= 1;
    }
    else if($action == 'next')
    {
        $month += 1;
    }
    // else just show the current month
    
    list($month, $year) = explode('-', date('n-Y', (mktime(0, 0, 1, $month, 1, $year))));
    
    $data = generate_month_array($month, $year, true);
    
    $return_array['data'] = $data;
    $return_array['data']['cal_h_month'] = $month;
    $return_array['data']['cal_h_year'] = $year;
    $return_array['data']['cal_month_name'] = '<b>' . $user->lang['CALENDAR']['LONG_MONTH'][(int)$month] . ' ' . date('Y', (mktime(0, 0, 1, $month, 1, $year))) . '</b>';
    $return_array['mode'] = 'update_block'; // So the client side handler knows what to do
}

if(sizeof($return_array))
{
    echo serialize($return_array);   
}
else
{
    die('No data received');
}

?>
