<?php

/**
*
* @package Portal - Topic Calendar Block
* @version $Id: install.php 505 2009-04-24 15:18:52Z kevin74 $
* @copyright (c) 2008 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

$current_version = '1.0.0b3.2'; // we'll follow the calendar versions

// If only checking version, exit.
if( defined('IN_PHPBB') )
{
	return;
}

define('IN_PHPBB', true);

$phpEx = substr(strrchr(__FILE__, '.'), 1);

$phpbb_root_path = '../';

include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/acp/acp_modules.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/lang_install_tcb');

$mode = request_var('mode', '');

$page_title = 'Portal - Topic Calendar Block v' . $current_version;
$old_configs = array('portal_topic_calendar', 'portal_topic_calendar_version');

if( $user->data['is_registered'] && $auth->acl_get('a_') ) 	 
{
	$version_array = array('0.0.1', '1.0.0b3');
	
	$old_version = 0;
	$installed = $updated = $uninstalled = false;
	
	$sql = 'SELECT config_value as version 
			FROM ' . PORTAL_CONFIG_TABLE . "
			WHERE config_name = 'portal_topic_calendar_version'";
	$result = @$db->sql_query_limit($sql, 1);
	$version = $db->sql_fetchrow($result);
	if(sizeof($version))
	{
		$old_version = strtolower($version['version']);
	}
	$db->sql_freeresult( $result );
	
	$check_mode = 'none';
	
	if( $old_version == 0 )
	{
		$check_mode = 'install';
	}
	elseif(version_compare(strtolower($old_version), strtolower($current_version), "<") === TRUE)
	{
		$check_mode = 'update';
	}
	
	$confirm = request_var('confirm', 0);
	
	$error_array = array();
	
	function split_sql_file($sql, $delimiter)
	{
		$sql = str_replace("\r" , '', $sql);
		$data = preg_split('/' . preg_quote($delimiter, '/') . '$/m', $sql);
	
		$data = array_map('trim', $data);
	
		// The empty case
		$end_data = end($data);
	
		if (empty($end_data))
		{
			unset($data[key($data)]);
		}
	
		return $data;
	}
	
	function db_error($error, $sql, $line, $file, $skip = false)
	{
		global $error, $lang, $db;
	
		if($skip)
		{
			$error_array[] = 	'<b>' . $user->lang['GENERAL_ERROR'] . ': ' . basename($file) . ' [ ' . $line . ' ]</b><br />
						<b style="color:red">' . $error . '</b><br />&#187; SQL:' . $sql;
			return;
		} 
		else
		{
			include $phpbb_root_path . 'install_tcb/style/layout_header.php';
			echo '<div class="errorbox">
					<h3>'. $user->lang['GENERAL_ERROR'] .'</h3>
					<p><b>' . $error . '</b><br />&#187; SQL:' . $sql . '<br />
					' . basename($file) . ' [ ' . $line . ' ]</p>
				</div>';		
			include $phpbb_root_path . 'install_tcb/style/layout_footer.php';
			exit;
		}
	}
	
	function remove_comments(&$output)
	{
		$lines = explode("\n", $output);
		$output = '';
	
		// try to keep mem. use down
		$linecount = sizeof($lines);
	
		$in_comment = false;
		for ($i = 0; $i < $linecount; $i++)
		{
			if (trim($lines[$i]) == '/*')
			{
				$in_comment = true;
			}
	
			if (!$in_comment)
			{
				$output .= $lines[$i] . "\n";
			}
	
			if (trim($lines[$i]) == '*/')
			{
				$in_comment = false;
			}
		}
	
		unset($lines);
		return $output;
	}
	
	function remove_remarks(&$sql)
	{
		$sql = preg_replace('/\n{2,}/', "\n", preg_replace('/^#.*$/m', "\n", $sql));
	}

	function drop_table($table)
	{
		global $db, $table_prefix, $db_schema;

		$table_name = substr($table . '#', 6, -1);

		if ($db->sql_layer != 'mssql')
		{
			$sql = 'DROP TABLE IF EXISTS ' . $table_prefix . $table_name;
			$result = $db->sql_query($sql);
			$db->sql_freeresult($result);
		}
		else
		{
			$sql = 'if exists (select * from sysobjects where name = ' . $table_prefix . $table_name . ')
				drop table ' . $table_prefix . $table_name;
			$result = $db->sql_query($sql);
			$db->sql_freeresult($result);
		}
	}	
	
	// What sql_layer should we use?
	switch ($db->sql_layer)
	{
		case 'mysql':
			$db_schema = 'mysql_40';
			$delimiter = ';';
			$comments = 'remove_remarks';
		break;
	
		case 'mysql4':
			if (version_compare($db->sql_server_info(true), '4.1.3', '>='))
			{
				$db_schema = 'mysql_41';
			}
			else
			{
				$db_schema = 'mysql_40';
			}
			$delimiter = ';';
			$comments = 'remove_remarks';
		break;
	
		case 'mysqli':
			$db_schema = 'mysql_41';
			$delimiter = ';';
			$comments = 'remove_remarks';
		break;
	
		case 'mssql':
		case 'mssql_odbc':
			$db_schema = 'mssql';
			$delimiter = 'GO';
			$comments = 'remove_comments';
		break;
	
		case 'postgres':
			$db_schema = 'postgres';
			$delimiter = ';';
			$comments = 'remove_comments';
		break;
	
		case 'sqlite':
			$db_schema = 'sqlite';
			$delimiter = ';';
			$comments = 'remove_remarks';
		break;
	
		case 'firebird':
			$db_schema = 'firebird';
			$delimiter = ';;';
			$comments = 'remove_remarks';
		break;
	
		case 'oracle':
			$db_schema = 'oracle';
			$delimiter = '/';
			$comments = 'remove_comments';
		break;
	
		default:
			trigger_error('Sorry, unsupported DBMS found: ' . $db->sql_layer);
		break;
	}
	
	// Get old version if it is installed.
	
	switch ($mode)
	{
	// Installing from scratch
	case 'install':
		if( $check_mode == 'install' )
		{
			if( $confirm == 1)
			{
				// locate the schema files
				$dbms_schema = $phpbb_root_path.'install_tcb/schemas/_' . $db_schema . '_schema.sql';
				$sql_query = @file_get_contents($dbms_schema);
				$sql_query = preg_replace('#phpbb_#i', $table_prefix, $sql_query);
				$comments($sql_query);
				$sql_query = split_sql_file($sql_query, $delimiter);
		
				// Make tables
				foreach ($sql_query as $sql)
				{
					if (!$db->sql_query($sql))
					{
						$error = $db->sql_error();
						db_error($error['message'], $sql, __LINE__, __FILE__);
					}
				}
				unset($sql_query);
			
				// Now for the data
		
				$sql_query = @file_get_contents($phpbb_root_path.'install_tcb/schemas/_schema_data.sql');
				switch ($db->sql_layer)
				{
					case 'mssql':
					case 'mssql_odbc':
						$sql_query = preg_replace('#\# MSSQL IDENTITY (phpbb_[a-z_]+) (ON|OFF) \##s', 'SET IDENTITY_INSERT \1 \2;', $sql_query);
					break;
					case 'postgres':
						$sql_query = preg_replace('#\# POSTGRES (BEGIN|COMMIT) \##s', '\1; ', $sql_query);
					break;
				}
		
				$sql_query = preg_replace('#phpbb_#i', $table_prefix, $sql_query);
				$sql_query = preg_replace('/\n{2,}/', "\n", preg_replace('/^#.*$/m', "\n", $sql_query));
				$sql_query = split_sql_file($sql_query, ';');
	
				$sql_query[] = "INSERT INTO {$table_prefix}portal_config (config_name, config_value) VALUES ('portal_topic_calendar_version', '{$current_version}')";

				foreach ($sql_query as $sql)
				{
					if (!$db->sql_query($sql))
					{
						$error = $db->sql_error();
						db_error($error['message'], $sql, __LINE__, __FILE__);
					}
				}
				unset($sql_query);
		
				// create the acp modules - Nickvergessen's code
				$modules = new acp_modules();
				$sql = 'SELECT module_id FROM ' . MODULES_TABLE . " WHERE module_langname = 'ACP_PORTAL_INFO' LIMIT 1";
				$result = $db->sql_query($sql);
				$acp_portal = $db->sql_fetchrow($result);
				$topic_calendar_block = array(
					'module_basename'	=> 'portal_topic_calendar',
					'module_enabled'	=> 1,
					'module_display'	=> 1,
					'parent_id'			=> $acp_portal['module_id'],
					'module_class'		=> 'acp',
					'module_langname'	=> 'ACP_PORTAL_TOPIC_CALENDAR_INFO',
					'module_mode'		=> 'topic_calendar',
					'module_auth'		=> ''
				);
				$modules->update_module_data($topic_calendar_block);
				// clear cache and log what we did
				$cache->purge();
				add_log('admin', $page_title . ' installed');
				$installed = true;
			}
			include($phpbb_root_path . 'install_tcb/style/layout_install.'.$phpEx);
		}
		else
		{
			include($phpbb_root_path . 'install_tcb/style/layout_menu.'.$phpEx);
		}
	break;
	// Updating
	case 'update':
		if( $check_mode == 'update' )
		{
			$confirm = request_var('confirm', '');
			if( $confirm == 1 )
			{
				$old_portal_configs = array('');

				//remove the columns
				$sql = 'DELETE FROM ' . PORTAL_CONFIG_TABLE . '
					WHERE ' . $db->sql_in_set('config_name', $old_portal_configs);
				$db->sql_query($sql);

				$portal_topic_calendar_update_array = array();
	
				include $phpbb_root_path.'install_tcb/schemas/update_schema.'.$phpEx;

				foreach( $sql_update as $sql_ver => $sql_data )
				{
					if( version_compare(strtolower($old_version), strtolower($sql_ver), ">=") === TRUE )
					{
						continue;
					} 
					else
					{
						$portal_topic_calendar_update_array = array_merge($portal_topic_calendar_update_array, $sql_data);
					}
				}
	
				$portal_topic_calendar_update_array[] = 'UPDATE ' . PORTAL_CONFIG_TABLE . " SET config_value='{$current_version}' WHERE config_name = 'portal_topic_calendar_version'";
	
				foreach($portal_topic_calendar_update_array as $sql)
				{
					$sql = preg_replace('#phpbb_#i', $table_prefix, $sql);
					if (!$db->sql_query($sql))
					{
						$error = $db->sql_error();
						db_error($error['message'], $sql, __LINE__, __FILE__);
					}
				}
				unset($portal_topic_calendar_update_array, $sql_update);

				// clear cache and log what we did
				$cache->purge();
				add_log('admin', $page_title . ' updated');
				$updated = true;
			}
			include($phpbb_root_path . 'install_tcb/style/layout_update.'.$phpEx);
		}
		else
		{
			include($phpbb_root_path . 'install_tcb/style/layout_menu.'.$phpEx);
		}
	
	break;
	// Uninstalling
	case 'uninstall':
		if( $old_version != 0 )
		{
			if( $confirm == 1)
			{
				//remove the columns
				$sql = 'DELETE FROM ' . PORTAL_CONFIG_TABLE . '
					WHERE ' . $db->sql_in_set('config_name', $old_configs);
				$db->sql_query($sql);
	
				//remove the modules
				$sql = 'SELECT right_id, module_id FROM ' . MODULES_TABLE . "
					WHERE module_langname = 'ACP_PORTAL_TOPIC_CALENDAR_INFO'
						";
				$result = $db->sql_query($sql);
				while ($row = $db->sql_fetchrow($result))
				{
					$sql = 'DELETE FROM ' . MODULES_TABLE . " WHERE module_id = '{$row['module_id']}'";
					$db->sql_query($sql);
					$sql = 'UPDATE ' . MODULES_TABLE . "
						SET left_id = left_id - 2
						WHERE module_class = 'acp'
							AND left_id > {$row['right_id']}";
					$db->sql_query($sql);
	
					$sql = 'UPDATE ' . MODULES_TABLE . "
						SET right_id = right_id - 2
						WHERE module_class = 'acp'
							AND right_id > {$row['right_id']}";
					$db->sql_query($sql);
				}
				$db->sql_freeresult($result);

				// clear cache and log what we did
				$cache->purge();
				add_log('admin', $page_title . ' uninstalled');
				$uninstalled = true;
			}
			include($phpbb_root_path . 'install_tcb/style/layout_uninstall.'.$phpEx);
		} 
		else
		{
			include($phpbb_root_path . 'install_tcb/style/layout_menu.'.$phpEx);
		}
	break;
	// Welcome page!
	default:
		include($phpbb_root_path . 'install_tcb/style/layout_menu.'.$phpEx);
	break;
	}
}
else
{
	echo login_box('', $user->lang['INSTALLER_NEEDS_ADMIN']); 
}

?>