<?php

/**
*
* @package phpBB3
* @copyright (c) 2007 M and J Media
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
/**
* Rewritten for Stargate Portal by Michae O'Toole copyright 2007
* @package phpBB3
* @copyright (c) 2007 phpbbireland
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
/**
* Rewritten for board3portal by Stuart McConnel (livewirestu) and Kevin (Saint_hh) www.board3.de
* @package - Board3portal
* @version $Id: calendar.php 505 2009-04-24 15:18:52Z kevin74 $
* @copyright (c) livewirestu 2008
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if (!defined('IN_PHPBB'))
{
   exit;
}

if (!defined('IN_PORTAL'))
{
   exit;
}

$phpEx = substr(strrchr(__FILE__, '.'), 1);

global $db, $user, $template, $auth, $phpEx, $phpbb_root_path, $config;

// Start session management
$user->setup('mods/calendar');
// Note this file is included after user->setup(), to ensure that some globals in functions_calendar.php can
// find the $user->lang array
include_once($phpbb_root_path . 'includes/functions_calendar.'.$phpEx);

// Lets start outputting the calendar table. Note that we don't put any information in the tables yet,
// this will be done using ajax, thus avoiding page refreshes when changing the calendar month on the block
// First, build the header, where the day initials will go.
$calendar_table = '<tr class="cal_block_header">';
for($y = 0 ; $y < 7 ; $y++)
{
    $calendar_table .= '<td id="cal_dname_' . $y . '" class="xrow1" align="center"></td>';
}
$calendar_table .= '</tr>';

// Now build the grid of calendar days (7 x 6)
for($y = 1 ; $y <= 6 ; $y++)
{
    $calendar_table .= '<tr id="r' . $y . '">';
/*
    for($x = 1 ; $x <= 7 ; $x++)
    {
        $calendar_table .= '<td class="row1" align="center"><table class="calendar" border="0" cellspacing="0" cellpadding="0" width="100%"><tr><td id="cal_' . (($y * 7) -7 + $x) . '" height="15" class="row2"></td></tr></table></td>';
    }
    $calendar_table .= '</tr>';
    */

    for($x = 1 ; $x <= 7 ; $x++)
    {
        $calendar_table .= '<td class="calendar" align="center" id="cal_' . (($y * 7) -7 + $x) . '"></td>';
    }
    $calendar_table .= '</tr>';

}

$template->assign_vars(array(
    'CALENDAR_TABLE'            => $calendar_table,
	'U_CALENDAR_MAIN'           => append_sid($phpbb_root_path . 'calendar.' . $phpEx . "?mode=main"),
    'HIDDEN_MONTH'              => gmdate('n', time() + $user->timezone + $user->dst),
    'HIDDEN_YEAR'               => gmdate('Y', time() + $user->timezone + $user->dst),
    'S_SGP_AJAX'                => true,
));

$s_show_upcoming_events     = $portal_config['portal_topic_calendar_dates'];
$upcoming_events_days       = $config['calendar_default_events_list_days'];
$s_show_upcoming_birthdays  = $portal_config['portal_topic_calendar_birthdays'];
//$upcoming_birthdays_days    = $config['calendar_default_bdays_list_days'];
$is_events = false;
$is_birthdays = false;

if($s_show_upcoming_events || $s_show_upcoming_birthdays)
{
    $now_month = gmdate('m', time() + $user->timezone + $user->dst);
    $now_year = gmdate('Y', time() + $user->timezone + $user->dst);
    $start_of_next_month = str_to_unix('00:00 am', ($now_month + 1) . "-01-$now_year") - 1;

    if($s_show_upcoming_events)
    {
        if($config['calendar_override_user'])
        {
            $event_list_date_span = $config['calendar_default_events_list_days'];
        }
        else
        {
            // Check how many days worth of events the user would like to view
            $event_list_date_span = $upcoming_events_days > $config['calendar_max_events_list_days'] ? $config['calendar_max_events_list_days'] : $upcoming_events_days;
        }
        $event_list_end_time = (time() + $user->timezone + $user->dst) + ($event_list_date_span * 24 * 60 * 60) - 1;

        $period = $event_list_end_time - str_to_unix('00:00 am', "$now_month-01-$now_year");
        $upcoming_events = get_events(0, $now_month, $now_year, $period);



        $is_events = false;
        foreach($upcoming_events as $event)
        {
            if(($event['end_time'] > (time() + $user->timezone + $user->dst )) && $event['start_time'] < ($event_list_end_time + $user->timezone + $user->dst))
            {
              list($m, $d, $y) = explode(',', gmdate('m,d,Y', ($event['start_time'] + $user->timezone + $user->dst)));
			$event_time = $event['start_time'] - $user->timezone - $user->dst;
                $template->assign_block_vars('event_list', array(
                    'TITLE'      => '<a href="calendar.php?mode=view&amp;month=' . $m . '&amp;day=' . $d . '&amp;year=' . $y . '" title="' . $event['event_name'] . '">' . $event['event_name'] . '</a>',
					'DATE'      => format_birthday($event_time, 'D j M'), // use of the B3P birthday format function
                ));
                $is_events = true;
            }
        }
    }

    if($s_show_upcoming_birthdays)
    {
		include($phpbb_root_path . 'portal/block/birthday_list.'.$phpEx);
    }
}

$template->assign_vars(array(
    'S_SHOW_UPCOMING_EVENTS'    => $s_show_upcoming_events,
    'UPCOMING_EVENTS_DAYS'      => $upcoming_events_days,
    'L_EVENTS_TIMEFRAME'        => sprintf($user->lang['UPCOMING_EVENTS_TIME_FRAME'], $upcoming_events_days),
    'S_IS_EVENTS'               => $is_events ? true : false,

    'S_SHOW_UPCOMING_BIRTHDAYS' => $s_show_upcoming_birthdays,
    'UPCOMING_BIRTHDAYS_DAYS'   => $upcoming_birthdays_days,
    'L_BIRTHDAYS_TIMEFRAME'     => sprintf($user->lang['UPCOMING_EVENTS_TIME_FRAME'], $upcoming_birthdays_days),
    'S_IS_BIRTHDAYS'            => $is_birthdays ? true : false,
	'S_DISPLAY_TOPIC_CALENDAR'  => true,
	'S_DISPLAY_TCB_BIRTHDAYS'	=> ( $portal_config['portal_topic_calendar_birthdays'] ) ? true : false,
	'S_DISPLAY_TCB_DATES'		=> ( $portal_config['portal_topic_calendar_dates'] ) ? true : false,
	'S_DISPLAY_TCB_MINICAL'		=> ( $portal_config['portal_topic_calendar_minical'] ) ? true : false,
	'S_NEW_EVENT'		        => $auth->acl_get('u_new_event'),
));



?>